/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         parser_parse
#define yylex           parser_lex
#define yyerror         parser_error
#define yydebug         parser_debug
#define yynerrs         parser_nerrs


/* Copy the first part of user declarations.  */
#line 19 "parser.y" /* yacc.c:339  */


#include "vbscript.h"
#include "parse.h"

#include "wine/debug.h"

WINE_DEFAULT_DEBUG_CHANNEL(vbscript);

static int parser_error(parser_ctx_t *,const char*);

static void parse_complete(parser_ctx_t*,BOOL);
static void handle_isexpression_script(parser_ctx_t *ctx, expression_t *expr);

static void source_add_statement(parser_ctx_t*,statement_t*);
static void source_add_class(parser_ctx_t*,class_decl_t*);

static void *new_expression(parser_ctx_t*,expression_type_t,size_t);
static expression_t *new_bool_expression(parser_ctx_t*,VARIANT_BOOL);
static expression_t *new_string_expression(parser_ctx_t*,const WCHAR*);
static expression_t *new_long_expression(parser_ctx_t*,expression_type_t,LONG);
static expression_t *new_double_expression(parser_ctx_t*,double);
static expression_t *new_unary_expression(parser_ctx_t*,expression_type_t,expression_t*);
static expression_t *new_binary_expression(parser_ctx_t*,expression_type_t,expression_t*,expression_t*);
static expression_t *new_new_expression(parser_ctx_t*,const WCHAR*);

static member_expression_t *new_member_expression(parser_ctx_t*,expression_t*,const WCHAR*);
static call_expression_t *new_call_expression(parser_ctx_t*,expression_t*,expression_t*);
static call_expression_t *make_call_expression(parser_ctx_t*,expression_t*,expression_t*);

static void *new_statement(parser_ctx_t*,statement_type_t,size_t);
static statement_t *new_call_statement(parser_ctx_t*,BOOL,expression_t*);
static statement_t *new_assign_statement(parser_ctx_t*,expression_t*,expression_t*);
static statement_t *new_set_statement(parser_ctx_t*,member_expression_t*,expression_t*,expression_t*);
static statement_t *new_dim_statement(parser_ctx_t*,dim_decl_t*);
static statement_t *new_redim_statement(parser_ctx_t*,const WCHAR*,BOOL,expression_t*);
static statement_t *new_while_statement(parser_ctx_t*,statement_type_t,expression_t*,statement_t*);
static statement_t *new_forto_statement(parser_ctx_t*,const WCHAR*,expression_t*,expression_t*,expression_t*,statement_t*);
static statement_t *new_foreach_statement(parser_ctx_t*,const WCHAR*,expression_t*,statement_t*);
static statement_t *new_if_statement(parser_ctx_t*,expression_t*,statement_t*,elseif_decl_t*,statement_t*);
static statement_t *new_function_statement(parser_ctx_t*,function_decl_t*);
static statement_t *new_onerror_statement(parser_ctx_t*,BOOL);
static statement_t *new_const_statement(parser_ctx_t*,const_decl_t*);
static statement_t *new_select_statement(parser_ctx_t*,expression_t*,case_clausule_t*);
static statement_t *new_with_statement(parser_ctx_t*,expression_t*,statement_t*);

static dim_decl_t *new_dim_decl(parser_ctx_t*,const WCHAR*,BOOL,dim_list_t*);
static dim_list_t *new_dim(parser_ctx_t*,unsigned,dim_list_t*);
static elseif_decl_t *new_elseif_decl(parser_ctx_t*,expression_t*,statement_t*);
static function_decl_t *new_function_decl(parser_ctx_t*,const WCHAR*,function_type_t,unsigned,arg_decl_t*,statement_t*);
static arg_decl_t *new_argument_decl(parser_ctx_t*,const WCHAR*,BOOL);
static const_decl_t *new_const_decl(parser_ctx_t*,const WCHAR*,expression_t*);
static case_clausule_t *new_case_clausule(parser_ctx_t*,expression_t*,statement_t*,case_clausule_t*);

static class_decl_t *new_class_decl(parser_ctx_t*);
static class_decl_t *add_class_function(parser_ctx_t*,class_decl_t*,function_decl_t*);
static class_decl_t *add_dim_prop(parser_ctx_t*,class_decl_t*,dim_decl_t*,unsigned);

static statement_t *link_statements(statement_t*,statement_t*);

#define STORAGE_IS_PRIVATE    1
#define STORAGE_IS_DEFAULT    2

#define CHECK_ERROR if(((parser_ctx_t*)ctx)->hres != S_OK) YYABORT


#line 139 "parser.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser.tab.h".  */
#ifndef YY_PARSER_PARSER_TAB_H_INCLUDED
# define YY_PARSER_PARSER_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int parser_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    tEXPRESSION = 258,
    tEOF = 259,
    tNL = 260,
    tEMPTYBRACKETS = 261,
    tEXPRLBRACKET = 262,
    tLTEQ = 263,
    tGTEQ = 264,
    tNEQ = 265,
    tSTOP = 266,
    tME = 267,
    tREM = 268,
    tDOT = 269,
    tTRUE = 270,
    tFALSE = 271,
    tNOT = 272,
    tAND = 273,
    tOR = 274,
    tXOR = 275,
    tEQV = 276,
    tIMP = 277,
    tIS = 278,
    tMOD = 279,
    tCALL = 280,
    tSUB = 281,
    tFUNCTION = 282,
    tGET = 283,
    tLET = 284,
    tCONST = 285,
    tDIM = 286,
    tREDIM = 287,
    tPRESERVE = 288,
    tIF = 289,
    tELSE = 290,
    tELSEIF = 291,
    tEND = 292,
    tTHEN = 293,
    tEXIT = 294,
    tWHILE = 295,
    tWEND = 296,
    tDO = 297,
    tLOOP = 298,
    tUNTIL = 299,
    tFOR = 300,
    tTO = 301,
    tEACH = 302,
    tIN = 303,
    tSELECT = 304,
    tCASE = 305,
    tWITH = 306,
    tBYREF = 307,
    tBYVAL = 308,
    tOPTION = 309,
    tNOTHING = 310,
    tEMPTY = 311,
    tNULL = 312,
    tCLASS = 313,
    tSET = 314,
    tNEW = 315,
    tPUBLIC = 316,
    tPRIVATE = 317,
    tNEXT = 318,
    tON = 319,
    tRESUME = 320,
    tGOTO = 321,
    tIdentifier = 322,
    tString = 323,
    tDEFAULT = 324,
    tERROR = 325,
    tEXPLICIT = 326,
    tPROPERTY = 327,
    tSTEP = 328,
    tInt = 329,
    tDouble = 330
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 91 "parser.y" /* yacc.c:355  */

    const WCHAR *string;
    statement_t *statement;
    expression_t *expression;
    member_expression_t *member;
    elseif_decl_t *elseif;
    dim_decl_t *dim_decl;
    dim_list_t *dim_list;
    function_decl_t *func_decl;
    arg_decl_t *arg_decl;
    class_decl_t *class_decl;
    const_decl_t *const_decl;
    case_clausule_t *case_clausule;
    unsigned uint;
    LONG integer;
    BOOL boolean;
    double dbl;

#line 274 "parser.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int parser_parse (parser_ctx_t *ctx);

#endif /* !YY_PARSER_PARSER_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 290 "parser.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  50
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1235

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  92
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  65
/* YYNRULES -- Number of rules.  */
#define YYNRULES  191
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  367

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   330

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    86,     2,
      78,    79,    89,    87,    82,    83,    81,    90,    80,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    76,     2,
      85,    77,    84,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,    88,     2,    91,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   153,   153,   154,   157,   158,   160,   162,   163,   166,
     167,   170,   171,   172,   175,   176,   179,   180,   183,   186,
     187,   188,   189,   190,   193,   195,   196,   198,   199,   201,
     202,   204,   207,   210,   211,   212,   213,   214,   215,   216,
     217,   219,   220,   221,   222,   223,   225,   227,   229,   233,
     234,   235,   239,   240,   243,   244,   247,   248,   249,   252,
     253,   256,   257,   260,   263,   264,   267,   268,   271,   272,
     275,   277,   278,   281,   283,   286,   287,   290,   291,   294,
     298,   299,   302,   303,   304,   308,   309,   312,   313,   316,
     317,   320,   321,   322,   324,   326,   329,   330,   333,   334,
     337,   338,   341,   342,   345,   346,   349,   350,   353,   354,
     357,   358,   359,   360,   361,   362,   363,   364,   367,   368,
     371,   372,   373,   376,   377,   380,   381,   385,   386,   388,
     392,   393,   396,   397,   398,   401,   402,   403,   406,   407,
     408,   412,   413,   414,   415,   416,   417,   418,   421,   422,
     423,   426,   427,   430,   431,   434,   437,   438,   439,   441,
     443,   445,   446,   447,   448,   451,   453,   455,   459,   461,
     465,   466,   469,   470,   471,   474,   475,   478,   479,   482,
     483,   484,   488,   489,   490,   491,   492,   493,   497,   498,
     499,   500
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "tEXPRESSION", "tEOF", "tNL",
  "tEMPTYBRACKETS", "tEXPRLBRACKET", "tLTEQ", "tGTEQ", "tNEQ", "tSTOP",
  "tME", "tREM", "tDOT", "tTRUE", "tFALSE", "tNOT", "tAND", "tOR", "tXOR",
  "tEQV", "tIMP", "tIS", "tMOD", "tCALL", "tSUB", "tFUNCTION", "tGET",
  "tLET", "tCONST", "tDIM", "tREDIM", "tPRESERVE", "tIF", "tELSE",
  "tELSEIF", "tEND", "tTHEN", "tEXIT", "tWHILE", "tWEND", "tDO", "tLOOP",
  "tUNTIL", "tFOR", "tTO", "tEACH", "tIN", "tSELECT", "tCASE", "tWITH",
  "tBYREF", "tBYVAL", "tOPTION", "tNOTHING", "tEMPTY", "tNULL", "tCLASS",
  "tSET", "tNEW", "tPUBLIC", "tPRIVATE", "tNEXT", "tON", "tRESUME",
  "tGOTO", "tIdentifier", "tString", "tDEFAULT", "tERROR", "tEXPLICIT",
  "tPROPERTY", "tSTEP", "tInt", "tDouble", "':'", "'='", "'('", "')'",
  "'0'", "'.'", "','", "'-'", "'>'", "'<'", "'&'", "'+'", "'\\\\'", "'*'",
  "'/'", "'^'", "$accept", "Program", "OptionExplicit_opt",
  "SourceElements", "ExpressionNl_opt", "BodyStatements",
  "StatementsNl_opt", "StatementsNl", "StatementNl", "Statement",
  "SimpleStatement", "MemberExpression", "Preserve_opt", "DimDeclList",
  "DimDecl", "DimList", "ConstDeclList", "ConstDecl", "ConstExpression",
  "DoType", "Step_opt", "IfStatement", "EndIf_opt", "ElseIfs_opt",
  "ElseIfs", "ElseIf", "Else_opt", "CaseClausules", "Arguments",
  "Arguments_opt", "ArgumentList_opt", "ArgumentList", "EmptyBrackets_opt",
  "ExpressionList", "Expression", "EqvExpression", "XorExpression",
  "OrExpression", "AndExpression", "NotExpression", "EqualityExpression",
  "ConcatExpression", "AdditiveExpression", "ModExpression",
  "IntdivExpression", "MultiplicativeExpression", "ExpExpression",
  "SignExpression", "UnaryExpression", "CallExpression",
  "LiteralExpression", "NumericLiteralExpression", "IntegerValue",
  "PrimaryExpression", "ClassDeclaration", "ClassBody", "PropertyDecl",
  "FunctionDecl", "Storage_opt", "Storage", "ArgumentsDecl_opt",
  "ArgumentDeclList", "ArgumentDecl", "Identifier", "StSep", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    58,    61,    40,    41,
      48,    46,    44,    45,    62,    60,    38,    43,    92,    42,
      47,    94
};
# endif

#define YYPACT_NINF -255

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-255)))

#define YYTABLE_NINF -171

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      62,   457,   -46,    43,  -255,   457,  -255,   -21,  -255,  -255,
     457,  -255,  -255,  -255,    65,  -255,  -255,  -255,  -255,  -255,
    -255,  -255,  -255,  -255,  -255,   527,   527,    49,  -255,    30,
      46,    67,    99,   108,  -255,     5,    42,   -42,   107,    59,
      83,    69,  -255,  -255,     3,  -255,  -255,  -255,  -255,    35,
    -255,   620,    -4,  -255,  -255,  -255,  -255,  -255,  -255,  -255,
     457,   457,   457,   457,   457,   527,   527,   527,   527,   527,
     527,   527,   527,   527,   527,   527,   527,   527,   527,   527,
    -255,   361,   102,  -255,    35,    35,  -255,  -255,  -255,   548,
      65,    65,   143,   457,    -3,   457,    22,   150,   138,   457,
      65,   175,   139,  -255,   123,   757,  -255,   204,   134,  -255,
     325,  -255,  -255,   125,  -255,  -255,    46,    67,    99,   108,
    -255,    42,    42,    42,    42,    42,    42,    42,   -42,   107,
     107,    59,    83,    69,    69,  -255,   361,   132,    10,  -255,
    -255,  -255,  -255,  -255,   130,   136,  -255,   133,    13,  -255,
     149,    25,  -255,  -255,  -255,  -255,  -255,    26,  -255,  -255,
     457,   824,    65,   152,   457,    26,    35,    31,     3,  -255,
     118,  -255,  -255,   757,   457,  -255,  -255,    65,    65,  -255,
    -255,   361,    65,   124,    65,  -255,   -36,   154,   690,   891,
      26,   190,  -255,   757,   186,   457,    26,   958,    96,  -255,
     162,   177,   161,  -255,   221,    15,    15,  -255,  -255,   120,
    -255,  -255,  -255,  -255,  -255,   170,   168,   361,   757,    21,
     213,   824,    24,  -255,   457,     8,   207,   223,    65,   228,
      35,    35,    94,   191,   457,  -255,  -255,  -255,   225,  -255,
      35,    35,  -255,  -255,   -36,   183,   230,  1159,   234,  -255,
    -255,   226,   457,    26,   457,   435,   235,   237,    35,   218,
      96,    96,    95,    35,   221,    65,    65,   210,   208,   287,
    1025,  1025,  -255,  -255,   457,   264,  -255,   230,   266,  -255,
    -255,   221,  1092,    12,    35,    35,    33,   255,  -255,    96,
      35,  -255,  -255,   239,   240,   241,    96,   287,   287,  -255,
     225,  -255,   273,  1025,   204,   279,   103,   315,   284,  -255,
    -255,   259,   457,    35,  1159,   757,   457,  -255,  -255,  -255,
      15,   245,   247,  -255,  -255,  -255,  -255,   302,  -255,   303,
     328,   958,   301,  -255,   221,  1092,  -255,   207,  -255,    35,
     225,   225,  -255,  -255,   757,  -255,  -255,   275,  -255,  1025,
     257,   265,  -255,  -255,   306,    35,    35,   274,  1025,  1025,
    -255,   308,   310,   276,   277,  -255,  -255
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       4,     9,     0,     0,     6,     0,   154,     0,   141,   142,
       0,   147,   145,   146,     0,   182,   143,   183,   184,   185,
     186,   187,   149,   150,   148,     0,     0,     0,   139,     0,
      98,   100,   102,   104,   106,   108,   110,   118,   120,   123,
     125,   127,   130,   132,   136,   135,   144,   138,    49,     0,
       1,   170,     0,    51,   109,   137,   133,   134,     3,    10,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      85,     0,     0,   140,   188,   189,     5,     2,    41,     0,
       0,     0,    52,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   173,   174,     0,    19,     7,     0,    21,    29,
      89,     8,    34,     0,   171,   153,    99,   101,   103,   105,
     107,   116,   115,   112,   117,   111,   113,   114,   119,   122,
     121,   124,   126,   128,   129,   131,     0,     0,    91,    50,
     190,   191,    25,    44,    61,     0,    27,    54,    56,    53,
       0,     0,    39,    37,    35,    36,    38,     0,    66,    67,
       0,   170,     0,     0,     0,     0,     0,    87,     0,   172,
       0,    20,    18,    23,     0,    24,    90,     0,     0,    93,
      86,     0,     0,     0,     0,    58,     0,     0,   170,   170,
       0,     0,    15,    16,     0,     0,     0,   170,   170,    88,
       0,     0,     0,    22,    26,    94,    94,    92,    62,     0,
      63,    64,    55,   152,   151,     0,    59,     0,    14,    73,
       0,   170,    33,    17,     0,     0,    82,     0,     0,     0,
     163,   157,     0,   171,     0,    42,    43,    95,     0,   175,
       0,     0,    65,    57,     0,     0,    75,   170,     0,    71,
      30,     0,     0,     0,     0,     0,     0,     0,   161,     0,
     170,   170,     0,   159,    40,     0,     0,     0,   177,    94,
     170,   170,    60,    28,     0,    80,    76,    77,    73,    74,
      31,    32,   170,    68,     0,     0,    96,     0,    48,   170,
       0,   164,   158,     0,     0,     0,   170,    94,    94,   176,
       0,   179,     0,   170,    12,     0,     0,     0,     0,    78,
      72,     0,     0,     0,   170,    14,     0,    47,   162,   155,
      94,     0,     0,   160,   180,   181,   178,     0,    13,     0,
       0,   170,     0,    46,    69,   170,    83,    82,    97,     0,
       0,     0,   168,   169,    14,    81,    70,     0,    84,   170,
       0,     0,    79,    45,     0,     0,     0,     0,   170,   170,
     165,     0,     0,     0,     0,   166,   167
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -255,  -255,  -255,  -255,  -255,  -254,  -185,  -192,   -40,   -85,
    -255,   249,  -255,   167,   126,   109,   176,  -255,  -255,   135,
    -255,  -255,    74,  -255,    82,  -255,  -255,    23,   195,  -255,
    -255,  -107,  -247,    47,     1,   304,   305,   307,   309,    16,
    -255,   214,   293,   117,   292,   294,   128,    34,   282,   -44,
     196,   165,  -255,  -255,  -255,  -118,  -255,  -190,  -188,  -182,
    -201,    86,  -139,   -14,    71
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     3,     4,    51,    27,   302,   191,   192,   193,   107,
     108,    28,   150,   146,   147,   215,   143,   144,   210,   160,
     313,   109,   249,   275,   276,   277,   308,   256,    83,   200,
     175,   137,   239,   285,   138,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,   216,    47,   111,   229,   230,   112,   113,   114,
     240,   267,   268,    48,    86
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      55,   223,    29,   176,   220,   241,    52,   110,   231,    80,
     232,   106,   227,    65,    66,    67,   233,   305,    60,   185,
     171,   237,   301,   152,   153,    49,    54,    84,    68,   179,
      60,    84,    60,   246,    60,    59,   251,    80,   213,   154,
      84,    73,   155,    50,   214,    74,    53,    60,    60,   328,
     324,   325,    60,    58,   254,    60,   247,   168,   248,    56,
      57,   110,   158,   188,   158,     1,   159,    61,   159,   156,
     231,   231,   232,   232,   207,   115,   145,   148,   233,   233,
     120,    81,    69,   163,    82,   312,   166,    62,   203,    70,
      71,   186,   181,   238,   151,   354,   157,   311,    85,   231,
     165,   232,    85,   219,   361,   362,   231,   233,   232,    81,
     245,    85,  -139,   135,   233,   316,     2,   110,    63,   339,
     177,   178,   336,   293,   294,    60,    64,   228,    72,   110,
     337,    75,    15,  -156,    17,    18,    19,    20,    21,     8,
       9,   330,   291,   292,   110,   110,   345,    76,   194,   110,
     347,   177,   178,   110,   295,   140,   141,   102,   103,   352,
      79,   190,   278,   205,   206,   196,   262,   161,   145,   139,
     148,   318,    77,    78,   110,   204,   149,   110,   323,    11,
      12,    13,     5,   201,   202,   304,   304,     6,   164,     7,
     129,   130,    16,   170,    22,    23,   225,   162,    22,    23,
      24,   350,   351,   110,    24,   133,   134,   209,   169,   172,
     173,   180,   182,   183,   148,   184,   187,    15,   304,    17,
      18,    19,    20,    21,   269,   253,   110,   110,   189,   195,
     303,   303,   217,   222,   224,   264,   197,   198,   110,   234,
     235,   236,    15,    60,    17,    18,    19,    20,    21,   243,
     244,   297,   298,   281,   250,   283,   286,   255,   263,   110,
     257,   221,   273,   303,   304,   259,   274,   226,   279,   280,
     110,   110,   287,   304,   304,   306,   290,   265,   266,   121,
     122,   123,   124,   125,   126,   127,   269,   110,   288,   299,
     300,   110,    15,   237,    17,    18,    19,    20,    21,   307,
     110,   260,   261,   248,   317,   110,   320,   321,   322,   303,
     327,   270,   271,   334,   110,   110,   329,   286,   303,   303,
     331,   332,   333,   340,   282,   341,   269,   269,   342,   289,
     343,    80,     5,   344,   296,   346,   355,     6,   353,     7,
       8,     9,    10,   357,   356,   363,   360,   364,   365,   366,
     167,   212,   310,   272,   258,   314,   315,   252,   208,   309,
     348,   319,   199,   338,   116,   128,   117,   131,     5,   118,
     132,   142,   119,     6,   242,     7,     8,     9,    10,   211,
      11,    12,    13,     0,   335,    14,   326,     0,     0,     0,
       0,     0,    15,    16,    17,    18,    19,    20,    21,    22,
      23,     0,   174,    81,     0,    24,    82,   136,    25,     0,
     349,     0,    26,     0,     0,     0,    11,    12,    13,     0,
       0,    14,     0,     0,     0,     0,   358,   359,    15,    16,
      17,    18,    19,    20,    21,    22,    23,     0,     0,     0,
       0,    24,     5,   136,    25,     0,     0,     6,    26,     7,
       8,     9,    10,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     5,     0,     0,     0,     0,     6,
     284,     7,     8,     9,    10,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      11,    12,    13,     0,     0,    14,     0,     0,     0,     0,
       0,     0,    15,    16,    17,    18,    19,    20,    21,    22,
      23,     0,    11,    12,    13,    24,     0,    14,    25,     0,
       0,     0,    26,     0,    15,    16,    17,    18,    19,    20,
      21,    22,    23,     0,     5,     0,     0,    24,     0,     6,
      25,     7,     8,     9,    26,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     5,     0,     0,     0,     0,
       6,     0,     7,     8,     9,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    11,    12,    13,     0,     0,    14,     0,     0,
       0,     0,     0,     0,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    11,    12,    13,     0,    24,    14,     0,
      25,     0,     0,     0,    26,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    87,     0,     0,     5,    24,     0,
       0,    88,     6,     0,     7,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    89,     0,     0,     0,     0,
      90,    91,    92,     0,    93,     0,     0,     0,     0,    94,
      95,     0,    96,     0,     0,    97,     0,     0,     0,    98,
       0,    99,     0,     0,     0,     0,     0,     0,   100,   101,
       0,   102,   103,     0,   104,     0,     0,    15,     0,    17,
      18,    19,    20,    21,     0,   218,   105,     5,     0,     0,
       0,    88,     6,     0,     7,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    89,     0,     0,     0,     0,
      90,    91,    92,     0,    93,     0,     0,     0,     0,    94,
      95,     0,    96,     0,     0,    97,     0,     0,     0,    98,
       0,    99,     0,     0,     0,     0,     0,     0,     0,   101,
       0,   102,   103,     0,   104,     0,     0,    15,     0,    17,
      18,    19,    20,    21,     5,     0,   105,     0,    88,     6,
       0,     7,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    89,  -170,  -170,     0,     0,    90,    91,    92,
       0,    93,     0,     0,     0,     0,    94,    95,     0,    96,
       0,     0,    97,     0,     0,     0,    98,     0,    99,     0,
       0,     0,     0,     0,     0,     0,   101,     0,   102,   103,
       0,   104,     0,     0,    15,     0,    17,    18,    19,    20,
      21,     5,     0,   105,     0,    88,     6,     0,     7,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    89,
       0,     0,     0,     0,    90,    91,    92,     0,    93,     0,
       0,     0,     0,    94,    95,     0,    96,   -14,     0,    97,
       0,     0,     0,    98,     0,    99,     0,     0,     0,     0,
       0,     0,     0,   101,     0,   102,   103,     0,   104,     0,
       0,    15,     0,    17,    18,    19,    20,    21,     5,     0,
     105,     0,    88,     6,     0,     7,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    89,     0,     0,     0,
       0,    90,    91,    92,     0,    93,     0,     0,     0,     0,
      94,    95,   -14,    96,     0,     0,    97,     0,     0,     0,
      98,     0,    99,     0,     0,     0,     0,     0,     0,     0,
     101,     0,   102,   103,     0,   104,     0,     0,    15,     0,
      17,    18,    19,    20,    21,     5,     0,   105,     0,    88,
       6,     0,     7,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    89,     0,     0,     0,     0,    90,    91,
      92,     0,    93,     0,     0,   -14,     0,    94,    95,     0,
      96,     0,     0,    97,     0,     0,     0,    98,     0,    99,
       0,     0,     0,     0,     0,     0,     0,   101,     0,   102,
     103,     0,   104,     0,     0,    15,     0,    17,    18,    19,
      20,    21,     5,     0,   105,     0,    88,     6,     0,     7,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      89,     0,     0,     0,     0,    90,    91,    92,     0,    93,
       0,     0,   -11,     0,    94,    95,     0,    96,     0,     0,
      97,     0,     0,     0,    98,     0,    99,     0,     0,     0,
       0,     0,     0,     0,   101,     0,   102,   103,     0,   104,
       0,     0,    15,     0,    17,    18,    19,    20,    21,     5,
       0,   105,     0,    88,     6,     0,     7,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    89,     0,     0,
       0,     0,    90,    91,    92,     0,    93,     0,     0,     0,
       0,    94,    95,     0,    96,     0,     0,    97,     0,     0,
       0,    98,     0,    99,     0,     0,     0,     0,     0,     0,
       0,   101,     0,   102,   103,   -14,   104,     0,     0,    15,
       0,    17,    18,    19,    20,    21,     5,     0,   105,     0,
      88,     6,     0,     7,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    89,     0,     0,     0,     0,    90,
      91,    92,     0,    93,     0,     0,     0,     0,    94,    95,
       0,    96,     0,     0,    97,     0,     0,     0,    98,     0,
      99,     0,     0,     0,     0,     0,     0,     0,   101,     0,
     102,   103,     0,   104,     0,     0,    15,     0,    17,    18,
      19,    20,    21,     0,     0,   105
};

static const yytype_int16 yycheck[] =
{
      14,   193,     1,   110,   189,   206,     5,    51,   198,     6,
     198,    51,   197,     8,     9,    10,   198,   271,    22,     6,
     105,     6,   269,    26,    27,    71,    10,     5,    23,   136,
      22,     5,    22,   218,    22,     5,   221,     6,    74,    42,
       5,    83,    45,     0,    80,    87,    67,    22,    22,   303,
     297,   298,    22,     4,    46,    22,    35,   101,    37,    25,
      26,   105,    40,    38,    40,     3,    44,    21,    44,    72,
     260,   261,   260,   261,   181,    79,    90,    91,   260,   261,
      64,    78,    77,    97,    81,    73,   100,    20,   173,    84,
      85,    78,    82,    78,    93,   349,    95,   282,    76,   289,
      99,   289,    76,   188,   358,   359,   296,   289,   296,    78,
     217,    76,    81,    79,   296,    82,    54,   161,    19,   320,
      26,    27,   314,    28,    29,    22,    18,    31,    86,   173,
     315,    24,    67,    37,    69,    70,    71,    72,    73,    15,
      16,    38,   260,   261,   188,   189,   331,    88,   162,   193,
     335,    26,    27,   197,    59,    84,    85,    61,    62,   344,
      91,   160,   247,   177,   178,   164,    72,    96,   182,    67,
     184,   289,    89,    90,   218,   174,    33,   221,   296,    55,
      56,    57,     7,    65,    66,   270,   271,    12,    50,    14,
      73,    74,    68,    70,    74,    75,   195,    47,    74,    75,
      80,   340,   341,   247,    80,    77,    78,    83,    69,     5,
      76,    79,    82,    77,   228,    82,    67,    67,   303,    69,
      70,    71,    72,    73,   238,   224,   270,   271,   157,    77,
     270,   271,    78,    43,    48,   234,   165,   166,   282,    77,
      63,    80,    67,    22,    69,    70,    71,    72,    73,    79,
      82,   265,   266,   252,    41,   254,   255,    50,    67,   303,
      37,   190,    79,   303,   349,    37,    36,   196,    34,    43,
     314,   315,    37,   358,   359,   274,    58,    52,    53,    65,
      66,    67,    68,    69,    70,    71,   300,   331,    51,    79,
      82,   335,    67,     6,    69,    70,    71,    72,    73,    35,
     344,   230,   231,    37,    49,   349,    67,    67,    67,   349,
      37,   240,   241,   312,   358,   359,    37,   316,   358,   359,
       5,    37,    63,    78,   253,    78,   340,   341,    26,   258,
      27,     6,     7,     5,   263,    34,    79,    12,    63,    14,
      15,    16,    17,    37,    79,    37,    72,    37,    72,    72,
     101,   184,   278,   244,   228,   284,   285,   222,   182,   277,
     337,   290,   167,   316,    60,    72,    61,    75,     7,    62,
      76,    89,    63,    12,   209,    14,    15,    16,    17,   183,
      55,    56,    57,    -1,   313,    60,   300,    -1,    -1,    -1,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    -1,    80,    81,    82,    83,    -1,
     339,    -1,    87,    -1,    -1,    -1,    55,    56,    57,    -1,
      -1,    60,    -1,    -1,    -1,    -1,   355,   356,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    -1,    -1,    -1,
      -1,    80,     7,    82,    83,    -1,    -1,    12,    87,    14,
      15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     7,    -1,    -1,    -1,    -1,    12,
      35,    14,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      55,    56,    57,    -1,    -1,    60,    -1,    -1,    -1,    -1,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    -1,    55,    56,    57,    80,    -1,    60,    83,    -1,
      -1,    -1,    87,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    -1,     7,    -1,    -1,    80,    -1,    12,
      83,    14,    15,    16,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     7,    -1,    -1,    -1,    -1,
      12,    -1,    14,    15,    16,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    55,    56,    57,    -1,    -1,    60,    -1,    -1,
      -1,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    55,    56,    57,    -1,    80,    60,    -1,
      83,    -1,    -1,    -1,    87,    67,    68,    69,    70,    71,
      72,    73,    74,    75,     4,    -1,    -1,     7,    80,    -1,
      -1,    11,    12,    -1,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,
      30,    31,    32,    -1,    34,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    -1,    -1,    45,    -1,    -1,    -1,    49,
      -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    58,    59,
      -1,    61,    62,    -1,    64,    -1,    -1,    67,    -1,    69,
      70,    71,    72,    73,    -1,     5,    76,     7,    -1,    -1,
      -1,    11,    12,    -1,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,
      30,    31,    32,    -1,    34,    -1,    -1,    -1,    -1,    39,
      40,    -1,    42,    -1,    -1,    45,    -1,    -1,    -1,    49,
      -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    59,
      -1,    61,    62,    -1,    64,    -1,    -1,    67,    -1,    69,
      70,    71,    72,    73,     7,    -1,    76,    -1,    11,    12,
      -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    25,    26,    27,    -1,    -1,    30,    31,    32,
      -1,    34,    -1,    -1,    -1,    -1,    39,    40,    -1,    42,
      -1,    -1,    45,    -1,    -1,    -1,    49,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    59,    -1,    61,    62,
      -1,    64,    -1,    -1,    67,    -1,    69,    70,    71,    72,
      73,     7,    -1,    76,    -1,    11,    12,    -1,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    -1,    -1,    30,    31,    32,    -1,    34,    -1,
      -1,    -1,    -1,    39,    40,    -1,    42,    43,    -1,    45,
      -1,    -1,    -1,    49,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    59,    -1,    61,    62,    -1,    64,    -1,
      -1,    67,    -1,    69,    70,    71,    72,    73,     7,    -1,
      76,    -1,    11,    12,    -1,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,
      -1,    30,    31,    32,    -1,    34,    -1,    -1,    -1,    -1,
      39,    40,    41,    42,    -1,    -1,    45,    -1,    -1,    -1,
      49,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      59,    -1,    61,    62,    -1,    64,    -1,    -1,    67,    -1,
      69,    70,    71,    72,    73,     7,    -1,    76,    -1,    11,
      12,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    30,    31,
      32,    -1,    34,    -1,    -1,    37,    -1,    39,    40,    -1,
      42,    -1,    -1,    45,    -1,    -1,    -1,    49,    -1,    51,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    59,    -1,    61,
      62,    -1,    64,    -1,    -1,    67,    -1,    69,    70,    71,
      72,    73,     7,    -1,    76,    -1,    11,    12,    -1,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,    34,
      -1,    -1,    37,    -1,    39,    40,    -1,    42,    -1,    -1,
      45,    -1,    -1,    -1,    49,    -1,    51,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    59,    -1,    61,    62,    -1,    64,
      -1,    -1,    67,    -1,    69,    70,    71,    72,    73,     7,
      -1,    76,    -1,    11,    12,    -1,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      -1,    -1,    30,    31,    32,    -1,    34,    -1,    -1,    -1,
      -1,    39,    40,    -1,    42,    -1,    -1,    45,    -1,    -1,
      -1,    49,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    59,    -1,    61,    62,    63,    64,    -1,    -1,    67,
      -1,    69,    70,    71,    72,    73,     7,    -1,    76,    -1,
      11,    12,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    30,
      31,    32,    -1,    34,    -1,    -1,    -1,    -1,    39,    40,
      -1,    42,    -1,    -1,    45,    -1,    -1,    -1,    49,    -1,
      51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    59,    -1,
      61,    62,    -1,    64,    -1,    -1,    67,    -1,    69,    70,
      71,    72,    73,    -1,    -1,    76
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    54,    93,    94,     7,    12,    14,    15,    16,
      17,    55,    56,    57,    60,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    80,    83,    87,    96,   103,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   145,   155,    71,
       0,    95,   126,    67,   131,   155,   139,   139,     4,     5,
      22,    21,    20,    19,    18,     8,     9,    10,    23,    77,
      84,    85,    86,    83,    87,    24,    88,    89,    90,    91,
       6,    78,    81,   120,     5,    76,   156,     4,    11,    25,
      30,    31,    32,    34,    39,    40,    42,    45,    49,    51,
      58,    59,    61,    62,    64,    76,   100,   101,   102,   113,
     141,   146,   149,   150,   151,    79,   127,   128,   129,   130,
     131,   133,   133,   133,   133,   133,   133,   133,   134,   135,
     135,   136,   137,   138,   138,   139,    82,   123,   126,    67,
     156,   156,   140,   108,   109,   155,   105,   106,   155,    33,
     104,   126,    26,    27,    42,    45,    72,   126,    40,    44,
     111,   156,    47,   155,    50,   126,   155,   103,   141,    69,
      70,   101,     5,    76,    77,   122,   123,    26,    27,   123,
      79,    82,    82,    77,    82,     6,    78,    67,    38,   156,
     126,    98,    99,   100,   155,    77,   126,   156,   156,   120,
     121,    65,    66,   101,   126,   155,   155,   123,   108,    83,
     110,   142,   105,    74,    80,   107,   144,    78,     5,   101,
      98,   156,    43,    99,    48,   126,   156,    98,    31,   147,
     148,   149,   150,   151,    77,    63,    80,     6,    78,   124,
     152,   152,   143,    79,    82,   123,    98,    35,    37,   114,
      41,    98,   111,   126,    46,    50,   119,    37,   106,    37,
     156,   156,    72,    67,   126,    52,    53,   153,   154,   155,
     156,   156,   107,    79,    36,   115,   116,   117,   101,    34,
      43,   126,   156,   126,    35,   125,   126,    37,    51,   156,
      58,   147,   147,    28,    29,    59,   156,   155,   155,    79,
      82,   124,    97,   100,   101,    97,   126,    35,   118,   116,
     114,    98,    73,   112,   156,   156,    82,    49,   147,   156,
      67,    67,    67,   147,   124,   124,   153,    37,    97,    37,
      38,     5,    37,    63,   126,   156,    99,    98,   125,   152,
      78,    78,    26,    27,     5,    98,    34,    98,   119,   156,
     154,   154,    98,    63,    97,    79,    79,    37,   156,   156,
      72,    97,    97,    37,    37,    72,    72
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    92,    93,    93,    94,    94,    95,    95,    95,    96,
      96,    97,    97,    97,    98,    98,    99,    99,   100,   101,
     101,   101,   101,   101,   102,   102,   102,   102,   102,   102,
     102,   102,   102,   102,   102,   102,   102,   102,   102,   102,
     102,   102,   102,   102,   102,   102,   102,   102,   102,   103,
     103,   103,   104,   104,   105,   105,   106,   106,   106,   107,
     107,   108,   108,   109,   110,   110,   111,   111,   112,   112,
     113,   113,   113,   114,   114,   115,   115,   116,   116,   117,
     118,   118,   119,   119,   119,   120,   120,   121,   121,   122,
     122,   123,   123,   123,   124,   124,   125,   125,   126,   126,
     127,   127,   128,   128,   129,   129,   130,   130,   131,   131,
     132,   132,   132,   132,   132,   132,   132,   132,   133,   133,
     134,   134,   134,   135,   135,   136,   136,   137,   137,   137,
     138,   138,   139,   139,   139,   140,   140,   140,   141,   141,
     141,   142,   142,   142,   142,   142,   142,   142,   143,   143,
     143,   144,   144,   145,   145,   146,   147,   147,   147,   147,
     147,   147,   147,   147,   147,   148,   148,   148,   149,   149,
     150,   150,   151,   151,   151,   152,   152,   153,   153,   154,
     154,   154,   155,   155,   155,   155,   155,   155,   156,   156,
     156,   156
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     3,     0,     3,     0,     2,     2,     0,
       2,     0,     1,     2,     0,     1,     1,     2,     2,     1,
       2,     1,     3,     2,     2,     2,     3,     2,     6,     1,
       5,     6,     6,     4,     1,     2,     2,     2,     2,     2,
       5,     1,     4,     4,     2,    10,     8,     7,     6,     1,
       3,     2,     0,     1,     1,     3,     1,     4,     2,     1,
       3,     1,     3,     3,     1,     2,     1,     1,     0,     2,
       9,     5,     7,     0,     2,     0,     1,     1,     2,     5,
       0,     3,     0,     4,     5,     1,     3,     0,     1,     0,
       1,     1,     3,     2,     0,     1,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     2,
       1,     3,     3,     3,     3,     3,     3,     3,     1,     3,
       1,     3,     3,     1,     3,     1,     3,     1,     3,     3,
       1,     3,     1,     2,     2,     1,     1,     2,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     7,     0,     1,     3,     2,
       4,     2,     4,     1,     3,     9,    11,    11,     8,     8,
       0,     1,     2,     1,     1,     1,     3,     1,     3,     2,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (ctx, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, ctx); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, parser_ctx_t *ctx)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (ctx);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, parser_ctx_t *ctx)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, ctx);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, parser_ctx_t *ctx)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              , ctx);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, ctx); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, parser_ctx_t *ctx)
{
  YYUSE (yyvaluep);
  YYUSE (ctx);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (parser_ctx_t *ctx)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, ctx);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 153 "parser.y" /* yacc.c:1646  */
    { parse_complete(ctx, (yyvsp[-2].boolean)); }
#line 1828 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 154 "parser.y" /* yacc.c:1646  */
    { handle_isexpression_script(ctx, (yyvsp[-1].expression)); }
#line 1834 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 157 "parser.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 1840 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 158 "parser.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 1846 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 162 "parser.y" /* yacc.c:1646  */
    { source_add_statement(ctx, (yyvsp[0].statement)); }
#line 1852 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 163 "parser.y" /* yacc.c:1646  */
    { source_add_class(ctx, (yyvsp[0].class_decl)); }
#line 1858 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 166 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = NULL; }
#line 1864 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 167 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[-1].expression); }
#line 1870 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 170 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = NULL; }
#line 1876 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 171 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1882 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 172 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = link_statements((yyvsp[-1].statement), (yyvsp[0].statement)); }
#line 1888 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 175 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = NULL; }
#line 1894 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 176 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1900 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 179 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1906 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 180 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = link_statements((yyvsp[-1].statement), (yyvsp[0].statement)); }
#line 1912 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 183 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[-1].statement); }
#line 1918 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 186 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = NULL; }
#line 1924 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 187 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1930 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 188 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1936 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 189 "parser.y" /* yacc.c:1646  */
    { (yyvsp[-2].statement)->next = (yyvsp[0].statement); (yyval.statement) = (yyvsp[-2].statement); }
#line 1942 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 190 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[-1].statement); }
#line 1948 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 193 "parser.y" /* yacc.c:1646  */
    { call_expression_t *call_expr = make_call_expression(ctx, (yyvsp[-1].expression), (yyvsp[0].expression)); CHECK_ERROR;
                                              (yyval.statement) = new_call_statement(ctx, FALSE, &call_expr->expr); CHECK_ERROR; }
#line 1955 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 195 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_call_statement(ctx, TRUE, (yyvsp[0].expression)); CHECK_ERROR; }
#line 1961 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 197 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_assign_statement(ctx, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 1967 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 198 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_dim_statement(ctx, (yyvsp[0].dim_decl)); CHECK_ERROR; }
#line 1973 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 200 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_redim_statement(ctx, (yyvsp[-3].string), (yyvsp[-4].boolean), (yyvsp[-1].expression)); CHECK_ERROR; }
#line 1979 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 201 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 1985 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 203 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_while_statement(ctx, STAT_WHILE, (yyvsp[-3].expression), (yyvsp[-1].statement)); CHECK_ERROR; }
#line 1991 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 205 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_while_statement(ctx, (yyvsp[-4].boolean) ? STAT_WHILELOOP : STAT_UNTIL, (yyvsp[-3].expression), (yyvsp[-1].statement));
                                              CHECK_ERROR; }
#line 1998 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 208 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_while_statement(ctx, (yyvsp[-1].boolean) ? STAT_DOWHILE : STAT_DOUNTIL, (yyvsp[0].expression), (yyvsp[-3].statement));
                                              CHECK_ERROR; }
#line 2005 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 210 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_while_statement(ctx, STAT_DOWHILE, NULL, (yyvsp[-1].statement)); CHECK_ERROR; }
#line 2011 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 211 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_function_statement(ctx, (yyvsp[0].func_decl)); CHECK_ERROR; }
#line 2017 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 212 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_statement(ctx, STAT_EXITDO, 0); CHECK_ERROR; }
#line 2023 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 213 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_statement(ctx, STAT_EXITFOR, 0); CHECK_ERROR; }
#line 2029 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 214 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_statement(ctx, STAT_EXITFUNC, 0); CHECK_ERROR; }
#line 2035 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 215 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_statement(ctx, STAT_EXITPROP, 0); CHECK_ERROR; }
#line 2041 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 216 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_statement(ctx, STAT_EXITSUB, 0); CHECK_ERROR; }
#line 2047 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 218 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_set_statement(ctx, (yyvsp[-3].member), (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2053 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 219 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_statement(ctx, STAT_STOP, 0); CHECK_ERROR; }
#line 2059 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 220 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_onerror_statement(ctx, TRUE); CHECK_ERROR; }
#line 2065 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 221 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_onerror_statement(ctx, FALSE); CHECK_ERROR; }
#line 2071 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 222 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_const_statement(ctx, (yyvsp[0].const_decl)); CHECK_ERROR; }
#line 2077 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 224 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_forto_statement(ctx, (yyvsp[-8].string), (yyvsp[-6].expression), (yyvsp[-4].expression), (yyvsp[-3].expression), (yyvsp[-1].statement)); CHECK_ERROR; }
#line 2083 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 226 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_foreach_statement(ctx, (yyvsp[-5].string), (yyvsp[-3].expression), (yyvsp[-1].statement)); }
#line 2089 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 228 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_select_statement(ctx, (yyvsp[-4].expression), (yyvsp[-2].case_clausule)); }
#line 2095 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 230 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_with_statement(ctx, (yyvsp[-4].expression), (yyvsp[-2].statement)); }
#line 2101 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 233 "parser.y" /* yacc.c:1646  */
    { (yyval.member) = new_member_expression(ctx, NULL, (yyvsp[0].string)); CHECK_ERROR; }
#line 2107 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 234 "parser.y" /* yacc.c:1646  */
    { (yyval.member) = new_member_expression(ctx, (yyvsp[-2].expression), (yyvsp[0].string)); CHECK_ERROR; }
#line 2113 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 235 "parser.y" /* yacc.c:1646  */
    { expression_t *dot_expr = new_expression(ctx, EXPR_DOT, sizeof(*dot_expr)); CHECK_ERROR;
                                              (yyval.member) = new_member_expression(ctx, dot_expr, (yyvsp[0].string)); CHECK_ERROR; }
#line 2120 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 239 "parser.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 2126 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 240 "parser.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 2132 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 243 "parser.y" /* yacc.c:1646  */
    { (yyval.dim_decl) = (yyvsp[0].dim_decl); }
#line 2138 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 244 "parser.y" /* yacc.c:1646  */
    { (yyvsp[-2].dim_decl)->next = (yyvsp[0].dim_decl); (yyval.dim_decl) = (yyvsp[-2].dim_decl); }
#line 2144 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 247 "parser.y" /* yacc.c:1646  */
    { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[0].string), FALSE, NULL); CHECK_ERROR; }
#line 2150 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 248 "parser.y" /* yacc.c:1646  */
    { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[-3].string), TRUE, (yyvsp[-1].dim_list)); CHECK_ERROR; }
#line 2156 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 249 "parser.y" /* yacc.c:1646  */
    { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[-1].string), TRUE, NULL); CHECK_ERROR; }
#line 2162 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 252 "parser.y" /* yacc.c:1646  */
    { (yyval.dim_list) = new_dim(ctx, (yyvsp[0].uint), NULL); }
#line 2168 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 253 "parser.y" /* yacc.c:1646  */
    { (yyval.dim_list) = new_dim(ctx, (yyvsp[-2].uint), (yyvsp[0].dim_list)); }
#line 2174 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 256 "parser.y" /* yacc.c:1646  */
    { (yyval.const_decl) = (yyvsp[0].const_decl); }
#line 2180 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 257 "parser.y" /* yacc.c:1646  */
    { (yyvsp[-2].const_decl)->next = (yyvsp[0].const_decl); (yyval.const_decl) = (yyvsp[-2].const_decl); }
#line 2186 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 260 "parser.y" /* yacc.c:1646  */
    { (yyval.const_decl) = new_const_decl(ctx, (yyvsp[-2].string), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2192 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 263 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2198 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 264 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_unary_expression(ctx, EXPR_NEG, (yyvsp[0].expression)); CHECK_ERROR; }
#line 2204 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 267 "parser.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 2210 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 268 "parser.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 2216 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 271 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = NULL;}
#line 2222 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 272 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2228 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 276 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_if_statement(ctx, (yyvsp[-7].expression), (yyvsp[-4].statement), (yyvsp[-3].elseif), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2234 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 277 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_if_statement(ctx, (yyvsp[-3].expression), (yyvsp[-1].statement), NULL, NULL); CHECK_ERROR; }
#line 2240 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 279 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = new_if_statement(ctx, (yyvsp[-5].expression), (yyvsp[-3].statement), NULL, (yyvsp[-1].statement)); CHECK_ERROR; }
#line 2246 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 286 "parser.y" /* yacc.c:1646  */
    { (yyval.elseif) = NULL; }
#line 2252 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 287 "parser.y" /* yacc.c:1646  */
    { (yyval.elseif) = (yyvsp[0].elseif); }
#line 2258 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 290 "parser.y" /* yacc.c:1646  */
    { (yyval.elseif) = (yyvsp[0].elseif); }
#line 2264 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 291 "parser.y" /* yacc.c:1646  */
    { (yyvsp[-1].elseif)->next = (yyvsp[0].elseif); (yyval.elseif) = (yyvsp[-1].elseif); }
#line 2270 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 295 "parser.y" /* yacc.c:1646  */
    { (yyval.elseif) = new_elseif_decl(ctx, (yyvsp[-3].expression), (yyvsp[0].statement)); }
#line 2276 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 298 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = NULL; }
#line 2282 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 299 "parser.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[0].statement); }
#line 2288 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 302 "parser.y" /* yacc.c:1646  */
    { (yyval.case_clausule) = NULL; }
#line 2294 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 303 "parser.y" /* yacc.c:1646  */
    { (yyval.case_clausule) = new_case_clausule(ctx, NULL, (yyvsp[0].statement), NULL); }
#line 2300 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 305 "parser.y" /* yacc.c:1646  */
    { (yyval.case_clausule) = new_case_clausule(ctx, (yyvsp[-3].expression), (yyvsp[-1].statement), (yyvsp[0].case_clausule)); }
#line 2306 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 308 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = NULL; }
#line 2312 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 309 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[-1].expression); }
#line 2318 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 312 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = NULL; }
#line 2324 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 313 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2330 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 316 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = NULL; }
#line 2336 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 317 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2342 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 320 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2348 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 321 "parser.y" /* yacc.c:1646  */
    { (yyvsp[-2].expression)->next = (yyvsp[0].expression); (yyval.expression) = (yyvsp[-2].expression); }
#line 2354 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 322 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_expression(ctx, EXPR_NOARG, 0); CHECK_ERROR; (yyval.expression)->next = (yyvsp[0].expression); }
#line 2360 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 329 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2366 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 330 "parser.y" /* yacc.c:1646  */
    { (yyvsp[-2].expression)->next = (yyvsp[0].expression); (yyval.expression) = (yyvsp[-2].expression); }
#line 2372 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 333 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2378 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 334 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_IMP, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2384 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 337 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2390 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 338 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_EQV, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2396 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 341 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2402 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 342 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_XOR, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2408 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 345 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2414 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 346 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_OR, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2420 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 349 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2426 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 350 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_AND, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2432 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 353 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2438 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 354 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_unary_expression(ctx, EXPR_NOT, (yyvsp[0].expression)); CHECK_ERROR; }
#line 2444 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 357 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2450 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 358 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_EQUAL, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2456 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 359 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_NEQUAL, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2462 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 360 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_GT, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2468 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 361 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_LT, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2474 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 362 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_GTEQ, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2480 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 363 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_LTEQ, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2486 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 364 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_IS, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2492 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 367 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2498 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 368 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_CONCAT, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2504 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 371 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2510 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 372 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_ADD, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2516 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 373 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_SUB, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2522 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 376 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2528 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 377 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_MOD, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2534 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 380 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2540 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 382 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_IDIV, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2546 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 385 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2552 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 387 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_MUL, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2558 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 389 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_DIV, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2564 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 392 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2570 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 393 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_binary_expression(ctx, EXPR_EXP, (yyvsp[-2].expression), (yyvsp[0].expression)); CHECK_ERROR; }
#line 2576 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 396 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2582 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 397 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_unary_expression(ctx, EXPR_NEG, (yyvsp[0].expression)); CHECK_ERROR; }
#line 2588 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 398 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2594 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 401 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2600 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 402 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2606 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 403 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_new_expression(ctx, (yyvsp[0].string)); CHECK_ERROR; }
#line 2612 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 406 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2618 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 407 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = &(yyvsp[0].member)->expr; }
#line 2624 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 408 "parser.y" /* yacc.c:1646  */
    { call_expression_t *expr = new_call_expression(ctx, (yyvsp[-1].expression), (yyvsp[0].expression)); CHECK_ERROR;
                                      (yyval.expression) = &expr->expr; }
#line 2631 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 412 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_bool_expression(ctx, VARIANT_TRUE); CHECK_ERROR; }
#line 2637 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 413 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_bool_expression(ctx, VARIANT_FALSE); CHECK_ERROR; }
#line 2643 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 414 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_string_expression(ctx, (yyvsp[0].string)); CHECK_ERROR; }
#line 2649 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 415 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2655 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 416 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_expression(ctx, EXPR_EMPTY, 0); CHECK_ERROR; }
#line 2661 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 417 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_expression(ctx, EXPR_NULL, 0); CHECK_ERROR; }
#line 2667 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 418 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_expression(ctx, EXPR_NOTHING, 0); CHECK_ERROR; }
#line 2673 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 421 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_long_expression(ctx, EXPR_INT, 0); CHECK_ERROR; }
#line 2679 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 422 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_long_expression(ctx, EXPR_INT, (yyvsp[0].integer)); CHECK_ERROR; }
#line 2685 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 423 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_double_expression(ctx, (yyvsp[0].dbl)); CHECK_ERROR; }
#line 2691 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 426 "parser.y" /* yacc.c:1646  */
    { (yyval.uint) = 0; }
#line 2697 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 427 "parser.y" /* yacc.c:1646  */
    { (yyval.uint) = (yyvsp[0].integer); }
#line 2703 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 430 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_unary_expression(ctx, EXPR_BRACKETS, (yyvsp[-1].expression)); }
#line 2709 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 431 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_expression(ctx, EXPR_ME, 0); CHECK_ERROR; }
#line 2715 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 434 "parser.y" /* yacc.c:1646  */
    { (yyvsp[-3].class_decl)->name = (yyvsp[-5].string); (yyval.class_decl) = (yyvsp[-3].class_decl); }
#line 2721 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 437 "parser.y" /* yacc.c:1646  */
    { (yyval.class_decl) = new_class_decl(ctx); }
#line 2727 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 438 "parser.y" /* yacc.c:1646  */
    { (yyval.class_decl) = add_class_function(ctx, new_class_decl(ctx), (yyvsp[0].func_decl)); CHECK_ERROR; }
#line 2733 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 439 "parser.y" /* yacc.c:1646  */
    { (yyval.class_decl) = add_class_function(ctx, (yyvsp[0].class_decl), (yyvsp[-2].func_decl)); CHECK_ERROR; }
#line 2739 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 441 "parser.y" /* yacc.c:1646  */
    { dim_decl_t *dim_decl = new_dim_decl(ctx, (yyvsp[0].string), FALSE, NULL); CHECK_ERROR;
                                                  (yyval.class_decl) = add_dim_prop(ctx, new_class_decl(ctx), dim_decl, (yyvsp[-1].uint)); CHECK_ERROR; }
#line 2746 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 443 "parser.y" /* yacc.c:1646  */
    { dim_decl_t *dim_decl = new_dim_decl(ctx, (yyvsp[-2].string), FALSE, NULL); CHECK_ERROR;
                                                  (yyval.class_decl) = add_dim_prop(ctx, (yyvsp[0].class_decl), dim_decl, (yyvsp[-3].uint)); CHECK_ERROR; }
#line 2753 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 445 "parser.y" /* yacc.c:1646  */
    { (yyval.class_decl) = add_dim_prop(ctx, new_class_decl(ctx), (yyvsp[0].dim_decl), 0); CHECK_ERROR; }
#line 2759 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 446 "parser.y" /* yacc.c:1646  */
    { (yyval.class_decl) = add_dim_prop(ctx, (yyvsp[0].class_decl), (yyvsp[-2].dim_decl), 0); CHECK_ERROR; }
#line 2765 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 447 "parser.y" /* yacc.c:1646  */
    { (yyval.class_decl) = add_class_function(ctx, new_class_decl(ctx), (yyvsp[0].func_decl)); CHECK_ERROR; }
#line 2771 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 448 "parser.y" /* yacc.c:1646  */
    { (yyval.class_decl) = add_class_function(ctx, (yyvsp[0].class_decl), (yyvsp[-2].func_decl)); CHECK_ERROR; }
#line 2777 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 452 "parser.y" /* yacc.c:1646  */
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-5].string), FUNC_PROPGET, (yyvsp[-8].uint), (yyvsp[-4].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2783 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 454 "parser.y" /* yacc.c:1646  */
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-7].string), FUNC_PROPLET, (yyvsp[-10].uint), (yyvsp[-5].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2789 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 456 "parser.y" /* yacc.c:1646  */
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-7].string), FUNC_PROPSET, (yyvsp[-10].uint), (yyvsp[-5].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2795 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 460 "parser.y" /* yacc.c:1646  */
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-5].string), FUNC_SUB, (yyvsp[-7].uint), (yyvsp[-4].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2801 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 462 "parser.y" /* yacc.c:1646  */
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[-5].string), FUNC_FUNCTION, (yyvsp[-7].uint), (yyvsp[-4].arg_decl), (yyvsp[-2].statement)); CHECK_ERROR; }
#line 2807 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 465 "parser.y" /* yacc.c:1646  */
    { (yyval.uint) = 0; }
#line 2813 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 466 "parser.y" /* yacc.c:1646  */
    { (yyval.uint) = (yyvsp[0].uint); }
#line 2819 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 469 "parser.y" /* yacc.c:1646  */
    { (yyval.uint) = STORAGE_IS_DEFAULT; }
#line 2825 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 470 "parser.y" /* yacc.c:1646  */
    { (yyval.uint) = 0; }
#line 2831 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 471 "parser.y" /* yacc.c:1646  */
    { (yyval.uint) = STORAGE_IS_PRIVATE; }
#line 2837 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 474 "parser.y" /* yacc.c:1646  */
    { (yyval.arg_decl) = NULL; }
#line 2843 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 475 "parser.y" /* yacc.c:1646  */
    { (yyval.arg_decl) = (yyvsp[-1].arg_decl); }
#line 2849 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 478 "parser.y" /* yacc.c:1646  */
    { (yyval.arg_decl) = (yyvsp[0].arg_decl); }
#line 2855 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 479 "parser.y" /* yacc.c:1646  */
    { (yyvsp[-2].arg_decl)->next = (yyvsp[0].arg_decl); (yyval.arg_decl) = (yyvsp[-2].arg_decl); }
#line 2861 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 482 "parser.y" /* yacc.c:1646  */
    { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[-1].string), TRUE); }
#line 2867 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 483 "parser.y" /* yacc.c:1646  */
    { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[-1].string), TRUE); }
#line 2873 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 484 "parser.y" /* yacc.c:1646  */
    { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[-1].string), FALSE); }
#line 2879 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 488 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2885 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 489 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2891 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 490 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2897 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 491 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2903 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 492 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2909 "parser.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 493 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2915 "parser.tab.c" /* yacc.c:1646  */
    break;


#line 2919 "parser.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (ctx, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (ctx, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, ctx);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, ctx);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (ctx, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, ctx);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, ctx);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 502 "parser.y" /* yacc.c:1906  */


static int parser_error(parser_ctx_t *ctx, const char *str)
{
    return 0;
}

static void source_add_statement(parser_ctx_t *ctx, statement_t *stat)
{
    if(!stat)
        return;

    if(ctx->stats) {
        ctx->stats_tail->next = stat;
        ctx->stats_tail = stat;
    }else {
        ctx->stats = ctx->stats_tail = stat;
    }
}

static void source_add_class(parser_ctx_t *ctx, class_decl_t *class_decl)
{
    class_decl->next = ctx->class_decls;
    ctx->class_decls = class_decl;
}

static void parse_complete(parser_ctx_t *ctx, BOOL option_explicit)
{
    ctx->parse_complete = TRUE;
    ctx->option_explicit = option_explicit;
}

static void handle_isexpression_script(parser_ctx_t *ctx, expression_t *expr)
{
    retval_statement_t *stat;

    ctx->parse_complete = TRUE;
    if(!expr)
        return;

    stat = new_statement(ctx, STAT_RETVAL, sizeof(*stat));
    if(!stat)
        return;

    stat->expr = expr;
    ctx->stats = &stat->stat;
}

static void *new_expression(parser_ctx_t *ctx, expression_type_t type, size_t size)
{
    expression_t *expr;

    expr = parser_alloc(ctx, size ? size : sizeof(*expr));
    if(expr) {
        expr->type = type;
        expr->next = NULL;
    }

    return expr;
}

static expression_t *new_bool_expression(parser_ctx_t *ctx, VARIANT_BOOL value)
{
    bool_expression_t *expr;

    expr = new_expression(ctx, EXPR_BOOL, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_string_expression(parser_ctx_t *ctx, const WCHAR *value)
{
    string_expression_t *expr;

    expr = new_expression(ctx, EXPR_STRING, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_long_expression(parser_ctx_t *ctx, expression_type_t type, LONG value)
{
    int_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_double_expression(parser_ctx_t *ctx, double value)
{
    double_expression_t *expr;

    expr = new_expression(ctx, EXPR_DOUBLE, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_unary_expression(parser_ctx_t *ctx, expression_type_t type, expression_t *subexpr)
{
    unary_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->subexpr = subexpr;
    return &expr->expr;
}

static expression_t *new_binary_expression(parser_ctx_t *ctx, expression_type_t type, expression_t *left, expression_t *right)
{
    binary_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->left = left;
    expr->right = right;
    return &expr->expr;
}

static member_expression_t *new_member_expression(parser_ctx_t *ctx, expression_t *obj_expr, const WCHAR *identifier)
{
    member_expression_t *expr;

    expr = new_expression(ctx, EXPR_MEMBER, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->obj_expr = obj_expr;
    expr->identifier = identifier;
    return expr;
}

static call_expression_t *new_call_expression(parser_ctx_t *ctx, expression_t *expr, expression_t *arguments)
{
    call_expression_t *call_expr;

    call_expr = new_expression(ctx, EXPR_CALL, sizeof(*call_expr));
    if(!call_expr)
        return NULL;

    call_expr->call_expr = expr;
    call_expr->args = arguments;
    return call_expr;
}

static call_expression_t *make_call_expression(parser_ctx_t *ctx, expression_t *callee_expr, expression_t *arguments)
{
    call_expression_t *call_expr;

    if(callee_expr->type == EXPR_MEMBER)
        return new_call_expression(ctx, callee_expr, arguments);
    if(callee_expr->type != EXPR_CALL) {
        FIXME("Unhandled for expr type %u\n", callee_expr->type);
        ctx->hres = E_FAIL;
        return NULL;
    }
    call_expr = (call_expression_t*)callee_expr;
    if(!call_expr->args) {
        call_expr->args = arguments;
        return call_expr;
    }

    if(call_expr->args->next) {
        FIXME("Invalid syntax: invalid use of parentheses for arguments\n");
        ctx->hres = E_FAIL;
        return NULL;
    }

    call_expr->args = new_unary_expression(ctx, EXPR_BRACKETS, call_expr->args);
    if(!call_expr->args)
        return NULL;
    if(!arguments)
        return call_expr;

    if(arguments->type != EXPR_NOARG) {
        FIXME("Invalid syntax: missing comma\n");
        ctx->hres = E_FAIL;
        return NULL;
    }

    call_expr->args->next = arguments->next;
    return call_expr;
}

static expression_t *new_new_expression(parser_ctx_t *ctx, const WCHAR *identifier)
{
    string_expression_t *expr;

    expr = new_expression(ctx, EXPR_NEW, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = identifier;
    return &expr->expr;
}

static void *new_statement(parser_ctx_t *ctx, statement_type_t type, size_t size)
{
    statement_t *stat;

    stat = parser_alloc(ctx, size ? size : sizeof(*stat));
    if(stat) {
        stat->type = type;
        stat->next = NULL;
    }

    return stat;
}

static statement_t *new_call_statement(parser_ctx_t *ctx, BOOL is_strict, expression_t *expr)
{
    call_expression_t *call_expr = NULL;
    call_statement_t *stat;

    stat = new_statement(ctx, STAT_CALL, sizeof(*stat));
    if(!stat)
        return NULL;

    switch(expr->type) {
    case EXPR_MEMBER:
        call_expr = new_call_expression(ctx, expr, NULL);
        break;
    case EXPR_CALL:
        call_expr = (call_expression_t*)expr;
        break;
    default:
        FIXME("Unsupported expr type %u\n", expr->type);
        ctx->hres = E_NOTIMPL;
    }
    if(!call_expr)
        return NULL;

    stat->expr = call_expr;
    stat->is_strict = is_strict;
    return &stat->stat;
}

static statement_t *new_assign_statement(parser_ctx_t *ctx, expression_t *left, expression_t *right)
{
    assign_statement_t *stat;

    stat = new_statement(ctx, STAT_ASSIGN, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->value_expr = right;

    if(left->type == EXPR_CALL) {
        stat->left_expr = (call_expression_t*)left;
    }else {
        stat->left_expr = new_call_expression(ctx, left, NULL);
        if(!stat->left_expr)
            return NULL;
    }

    return &stat->stat;
}

static statement_t *new_set_statement(parser_ctx_t *ctx, member_expression_t *left, expression_t *arguments, expression_t *right)
{
    assign_statement_t *stat;

    stat = new_statement(ctx, STAT_SET, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->value_expr = right;
    stat->left_expr = new_call_expression(ctx, &left->expr, arguments);
    if(!stat->left_expr)
        return NULL;

    return &stat->stat;
}

static dim_decl_t *new_dim_decl(parser_ctx_t *ctx, const WCHAR *name, BOOL is_array, dim_list_t *dims)
{
    dim_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->is_array = is_array;
    decl->dims = dims;
    decl->next = NULL;
    return decl;
}

static dim_list_t *new_dim(parser_ctx_t *ctx, unsigned val, dim_list_t *next)
{
    dim_list_t *ret;

    ret = parser_alloc(ctx, sizeof(*ret));
    if(!ret)
        return NULL;

    ret->val = val;
    ret->next = next;
    return ret;
}

static statement_t *new_dim_statement(parser_ctx_t *ctx, dim_decl_t *decls)
{
    dim_statement_t *stat;

    stat = new_statement(ctx, STAT_DIM, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->dim_decls = decls;
    return &stat->stat;
}

static statement_t *new_redim_statement(parser_ctx_t *ctx, const WCHAR *identifier, BOOL preserve, expression_t *dims)
{
    redim_statement_t *stat;

    stat = new_statement(ctx, STAT_REDIM, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->identifier = identifier;
    stat->preserve = preserve;
    stat->dims = dims;
    return &stat->stat;
}

static elseif_decl_t *new_elseif_decl(parser_ctx_t *ctx, expression_t *expr, statement_t *stat)
{
    elseif_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->expr = expr;
    decl->stat = stat;
    decl->next = NULL;
    return decl;
}

static statement_t *new_while_statement(parser_ctx_t *ctx, statement_type_t type, expression_t *expr, statement_t *body)
{
    while_statement_t *stat;

    stat = new_statement(ctx, type, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_forto_statement(parser_ctx_t *ctx, const WCHAR *identifier, expression_t *from_expr,
        expression_t *to_expr, expression_t *step_expr, statement_t *body)
{
    forto_statement_t *stat;

    stat = new_statement(ctx, STAT_FORTO, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->identifier = identifier;
    stat->from_expr = from_expr;
    stat->to_expr = to_expr;
    stat->step_expr = step_expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_foreach_statement(parser_ctx_t *ctx, const WCHAR *identifier, expression_t *group_expr,
        statement_t *body)
{
    foreach_statement_t *stat;

    stat = new_statement(ctx, STAT_FOREACH, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->identifier = identifier;
    stat->group_expr = group_expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_if_statement(parser_ctx_t *ctx, expression_t *expr, statement_t *if_stat, elseif_decl_t *elseif_decl,
        statement_t *else_stat)
{
    if_statement_t *stat;

    stat = new_statement(ctx, STAT_IF, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->if_stat = if_stat;
    stat->elseifs = elseif_decl;
    stat->else_stat = else_stat;
    return &stat->stat;
}

static statement_t *new_select_statement(parser_ctx_t *ctx, expression_t *expr, case_clausule_t *case_clausules)
{
    select_statement_t *stat;

    stat = new_statement(ctx, STAT_SELECT, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->case_clausules = case_clausules;
    return &stat->stat;
}

static statement_t *new_with_statement(parser_ctx_t *ctx, expression_t *expr, statement_t *body)
{
    with_statement_t *stat;

    stat = new_statement(ctx, STAT_WITH, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->body = body;
    return &stat->stat;
}

static case_clausule_t *new_case_clausule(parser_ctx_t *ctx, expression_t *expr, statement_t *stat, case_clausule_t *next)
{
    case_clausule_t *ret;

    ret = parser_alloc(ctx, sizeof(*ret));
    if(!ret)
        return NULL;

    ret->expr = expr;
    ret->stat = stat;
    ret->next = next;
    return ret;
}

static statement_t *new_onerror_statement(parser_ctx_t *ctx, BOOL resume_next)
{
    onerror_statement_t *stat;

    stat = new_statement(ctx, STAT_ONERROR, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->resume_next = resume_next;
    return &stat->stat;
}

static arg_decl_t *new_argument_decl(parser_ctx_t *ctx, const WCHAR *name, BOOL by_ref)
{
    arg_decl_t *arg_decl;

    arg_decl = parser_alloc(ctx, sizeof(*arg_decl));
    if(!arg_decl)
        return NULL;

    arg_decl->name = name;
    arg_decl->by_ref = by_ref;
    arg_decl->next = NULL;
    return arg_decl;
}

static function_decl_t *new_function_decl(parser_ctx_t *ctx, const WCHAR *name, function_type_t type,
        unsigned storage_flags, arg_decl_t *arg_decl, statement_t *body)
{
    function_decl_t *decl;

    if(storage_flags & STORAGE_IS_DEFAULT) {
        if(type == FUNC_PROPGET) {
            type = FUNC_DEFGET;
        }else {
            FIXME("Invalid default property\n");
            ctx->hres = E_FAIL;
            return NULL;
        }
    }

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->type = type;
    decl->is_public = !(storage_flags & STORAGE_IS_PRIVATE);
    decl->args = arg_decl;
    decl->body = body;
    decl->next = NULL;
    decl->next_prop_func = NULL;
    return decl;
}

static statement_t *new_function_statement(parser_ctx_t *ctx, function_decl_t *decl)
{
    function_statement_t *stat;

    stat = new_statement(ctx, STAT_FUNC, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->func_decl = decl;
    return &stat->stat;
}

static class_decl_t *new_class_decl(parser_ctx_t *ctx)
{
    class_decl_t *class_decl;

    class_decl = parser_alloc(ctx, sizeof(*class_decl));
    if(!class_decl)
        return NULL;

    class_decl->funcs = NULL;
    class_decl->props = NULL;
    class_decl->next = NULL;
    return class_decl;
}

static class_decl_t *add_class_function(parser_ctx_t *ctx, class_decl_t *class_decl, function_decl_t *decl)
{
    function_decl_t *iter;

    for(iter = class_decl->funcs; iter; iter = iter->next) {
        if(!wcsicmp(iter->name, decl->name)) {
            if(decl->type == FUNC_SUB || decl->type == FUNC_FUNCTION) {
                FIXME("Redefinition of %s::%s\n", debugstr_w(class_decl->name), debugstr_w(decl->name));
                ctx->hres = E_FAIL;
                return NULL;
            }

            while(1) {
                if(iter->type == decl->type) {
                    FIXME("Redefinition of %s::%s\n", debugstr_w(class_decl->name), debugstr_w(decl->name));
                    ctx->hres = E_FAIL;
                    return NULL;
                }
                if(!iter->next_prop_func)
                    break;
                iter = iter->next_prop_func;
            }

            iter->next_prop_func = decl;
            return class_decl;
        }
    }

    decl->next = class_decl->funcs;
    class_decl->funcs = decl;
    return class_decl;
}

static class_decl_t *add_dim_prop(parser_ctx_t *ctx, class_decl_t *class_decl, dim_decl_t *dim_decl, unsigned storage_flags)
{
    if(storage_flags & STORAGE_IS_DEFAULT) {
        FIXME("variant prop van't be default value\n");
        ctx->hres = E_FAIL;
        return NULL;
    }

    dim_decl->is_public = !(storage_flags & STORAGE_IS_PRIVATE);
    dim_decl->next = class_decl->props;
    class_decl->props = dim_decl;
    return class_decl;
}

static const_decl_t *new_const_decl(parser_ctx_t *ctx, const WCHAR *name, expression_t *expr)
{
    const_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->value_expr = expr;
    decl->next = NULL;
    return decl;
}

static statement_t *new_const_statement(parser_ctx_t *ctx, const_decl_t *decls)
{
    const_statement_t *stat;

    stat = new_statement(ctx, STAT_CONST, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->decls = decls;
    return &stat->stat;
}

static statement_t *link_statements(statement_t *head, statement_t *tail)
{
    statement_t *iter;

    for(iter = head; iter->next; iter = iter->next);
    iter->next = tail;

    return head;
}

void *parser_alloc(parser_ctx_t *ctx, size_t size)
{
    void *ret;

    ret = heap_pool_alloc(&ctx->heap, size);
    if(!ret)
        ctx->hres = E_OUTOFMEMORY;
    return ret;
}

HRESULT parse_script(parser_ctx_t *ctx, const WCHAR *code, const WCHAR *delimiter, DWORD flags)
{
    static const WCHAR html_delimiterW[] = {'<','/','s','c','r','i','p','t','>',0};

    ctx->code = ctx->ptr = code;
    ctx->end = ctx->code + lstrlenW(ctx->code);

    heap_pool_init(&ctx->heap);

    ctx->parse_complete = FALSE;
    ctx->hres = S_OK;

    ctx->last_token = tNL;
    ctx->last_nl = 0;
    ctx->stats = ctx->stats_tail = NULL;
    ctx->class_decls = NULL;
    ctx->option_explicit = FALSE;
    ctx->is_html = delimiter && !wcsicmp(delimiter, html_delimiterW);

    if(flags & SCRIPTTEXT_ISEXPRESSION)
        ctx->last_token = tEXPRESSION;

    parser_parse(ctx);

    if(FAILED(ctx->hres))
        return ctx->hres;
    if(!ctx->parse_complete) {
        FIXME("parser failed around %s\n", debugstr_w(ctx->code+20 > ctx->ptr ? ctx->code : ctx->ptr-20));
        return E_FAIL;
    }

    return S_OK;
}

void parser_release(parser_ctx_t *ctx)
{
    heap_pool_free(&ctx->heap);
}
